=== debian/changelog ===
qprompt (1.1.6-0ubuntu6) plucky; urgency=medium

  * Build with librhash1.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 12 Dec 2024 19:14:30 +0000

qprompt (1.1.6-0ubuntu5) noble; urgency=high

  * No change rebuild against libqt5core5t64, libqt5gui5t64,
    libqt5widgets5t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:48:25 +0200

qprompt (1.1.6-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:06:45 +0000

qprompt (1.1.6-0ubuntu3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:42:35 +0000

qprompt (1.1.6-0ubuntu2) mantic; urgency=medium

  * Upload to fix changelog/acceptance error

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 06 Sep 2023 07:56:30 -0700

qprompt (1.1.6-0ubuntu1) mantic; urgency=medium

  * Initial release. (LP: #2032131)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sun, 20 Aug 2023 11:41:28 -0700
