=== debian/control ===
Source: qprompt
Section: video
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 cmake-extras,
 extra-cmake-modules,
 kirigami2-dev,
 qml-module-org-kde-kcoreaddons,
 qml-module-qtquick-shapes,
 qtdeclarative5-dev-tools,
 libqt53drender5,
 libqt5quickshapes5,
 qtdeclarative5-dev,
 qt5-qmltooling-plugins,
 libqt53dcore5,
 libkf5kirigami2-doc,
 librhash1,
 libqt5svg5-dev,
 cmake-data,
 qml-module-qt-labs-qmlmodels,
 qml-module-qtqml-statemachine,
 libqt5quicktest5,
 libqt5x11extras5-dev,
 qml-module-qtquick-scene2d,
 libqt53dquickscene2d5,
 qtquickcontrols2-5-dev,
 gettext,
 libkf5auth-dev-bin,
 libkf5widgetsaddons-dev,
 libkf5iconthemes-dev,
 libkf5codecs-dev,
 libkf5guiaddons-dev,
 libkf5auth-dev,
 libkf5configwidgets-dev,
 libkf5itemviews-dev
Standards-Version: 4.6.1
Homepage: https://qprompt.app/
Vcs-Browser: https://github.com/Cuperino/QPrompt
Vcs-Git: https://github.com/Cuperino/QPrompt.git

Package: qprompt
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Teleprompter Software
 Personal teleprompter software for all video creators.
 Built with ease of use, productivity, control accuracy,
 and smooth performance in mind.
