=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/qprompt/usr/share/doc; \
	mv debian/qprompt/usr/doc/qprompt debian/qprompt/usr/share/doc/qprompt; \
	rm -r debian/qprompt/usr/doc; \
	rm -r debian/qprompt/usr/share/locale/LC_MESSAGES
